#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     LimeGreen
#property indicator_color2     Orange
#property indicator_color3     LimeGreen
#property indicator_color4     Orange
#property indicator_color5     Orange
#property indicator_width3     3
#property indicator_width4     3
#property indicator_width5     3
#property indicator_style1     STYLE_DOT
#property indicator_style2     STYLE_DOT
#property indicator_level1     0
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern string TimeFrame = "current time frame";
extern int    FastLen   = 12;
extern int    SlowLen   = 26;
extern int    Length    = 10;
extern double StDv      = 2.5;  
extern bool   drawDots  = false;            

//
//
//
//
//

double buffer1[];
double buffer2[];
double bbMacd[];
double buffer4[];
double buffer5[];
double buffer6[];
double slope[];

//
//
//
//
//

int    timeFrame;
string indicatorFileName;
string shortName;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,bbMacd);                               
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,buffer5);
   SetIndexBuffer(5,buffer6);
   SetIndexBuffer(6,slope);
   
      if (drawDots) {
            SetIndexStyle(2, DRAW_ARROW,0); SetIndexArrow(2, 159);
            SetIndexStyle(3, DRAW_ARROW,0); SetIndexArrow(3, 159);
            SetIndexStyle(4, DRAW_NONE);
         }
      else
         {
            SetIndexStyle(2, DRAW_LINE);
            SetIndexStyle(3, DRAW_LINE);
            SetIndexStyle(4, DRAW_LINE);
         }

   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
         
   IndicatorDigits(5);
  
   IndicatorShortName(timeFrameToString(timeFrame)+ "   BB Macd ("+FastLen+ "," +SlowLen+ "," +Length+")");
      SetIndexLabel(0, "Upperband");
      SetIndexLabel(1, "Lowerband");  
      SetIndexLabel(2, "BB Macd");
      SetIndexLabel(3, NULL);
      SetIndexLabel(4, NULL);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit()  {   return(0);  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int limit,i,counted_bars = IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       limit = MathMin(Bars - counted_bars,Bars-1);
       if (returnBars) { buffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (!drawDots) if (slope[limit]==-1) CleanPoint(limit,buffer4,buffer5);
      double alpha = 2.0 / (Length + 1.0);
      
      for(i = limit; i >= 0 ; i--)
      {
      
       bbMacd[i]   = iMA(NULL,0,FastLen,0,MODE_EMA,PRICE_CLOSE,i) - iMA(NULL,0,SlowLen,0,MODE_EMA,PRICE_CLOSE,i);
       buffer6[i]  = buffer6[i+1] + alpha*(bbMacd[i] - buffer6[i+1]); 
       double sDev = iDeviation(bbMacd, buffer6[i], Length, i);  
       buffer1[i]  = buffer6[i] + (StDv * sDev);
       buffer2[i]  = buffer6[i] - (StDv * sDev);    
       buffer4[i]  = EMPTY_VALUE;  
       buffer5[i]  = EMPTY_VALUE; 
       
       //
       //        
       //
       // 
         
       slope[i] = slope[i+1];
       if (bbMacd[i] > bbMacd[i+1]) slope[i] =  1; 
       if (bbMacd[i] < bbMacd[i+1]) slope[i] = -1; 
       if (slope[i]==-1) if (drawDots)     buffer4[i] = bbMacd[i];
                         else  PlotPoint(i,buffer4,buffer5,bbMacd);
       
    }
       
   return(0);
   }
       
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (!drawDots) if (slope[limit]==-1) CleanPoint(limit,buffer4,buffer5);
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         buffer1[i]= iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastLen,SlowLen,Length,StDv,0,y);
         buffer2[i]= iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastLen,SlowLen,Length,StDv,1,y);
         bbMacd[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastLen,SlowLen,Length,StDv,2,y);
         buffer4[i]= EMPTY_VALUE;
         buffer5[i]= EMPTY_VALUE;
         slope[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastLen,SlowLen,Length,StDv,6,y);
         
         if (drawDots && slope[i]==-1) buffer4[i] = bbMacd[i];
         
   }
   
   if (!drawDots) for (i=limit;i>=0;i--) if (slope[i]==-1) PlotPoint(i,buffer4,buffer5,bbMacd);

   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iDeviation(double& array[],double dMA, int period,int shift)
{
   double dSum = 0.00;
   int    i;

   for(i=0; i<period; i++) dSum += (array[shift+i]-dMA)*(array[shift+i]-dMA);
   
   return(MathSqrt(dSum/period));
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}
//+------------------------------------------------------------------+
 